<?php
//
//namespace App\Entity;
//
//use App\Repository\InterventionRepository;
//use Doctrine\DBAL\Types\Types;
//use Doctrine\ORM\Mapping as ORM;
//use Doctrine\Common\Collections\ArrayCollection;
//use Doctrine\Common\Collections\Collection;
//
//#[ORM\Entity(repositoryClass: InterventionRepository::class)]
//class Intervention
//{
//    #[ORM\Id]
//    #[ORM\GeneratedValue]
//    #[ORM\Column]
//    private ?int $id = null;
//
//    #[ORM\Column(length: 255)]
//    private ?string $Wording = null;
//
//    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
//    private ?\DateTimeInterface $Timestamp = null;
//
//    #[ORM\Column(length: 255)]
//    private ?string $Description = null;
//
//    #[ORM\Column(length: 255)]
//    private ?string $Address = null;
//
//    #[ORM\Column(length: 255)]
//    private ?string $Status = null;
//
////<<<<<<< HEAD
////    #[ORM\ManyToOne(targetEntity: Vehicule::class)]
////    private ?Vehicule $vehicule = null;
////
////=======
//    #[ORM\ManyToOne(inversedBy: 'interventions')]
//    #[ORM\JoinColumn(nullable: false)]
//    private ?Utilisateur $user = null;
//
//    #[ORM\ManyToOne]
//    #[ORM\JoinColumn(nullable: false)]
//    private ?Fault $fault = null;
//
//    #[ORM\ManyToOne(inversedBy: 'intervention')]
//    private ?Vehicle $vehicle = null;
//
//    #[ORM\ManyToMany(targetEntity: Stock::class)]
//    #[ORM\JoinTable(name: "intervention_stock")]
//    private Collection $stocks;
//
//    public function __construct()
//    {
//        $this->stocks = new ArrayCollection();
//    }
////>>>>>>> 4fc91211f0d814453d2ed97caf6a1d94d709058e
//
//    public function getId(): ?int
//    {
//        return $this->id;
//    }
//
//    public function getWording(): ?string
//    {
//        return $this->Wording;
//    }
//
//    public function setWording(string $Wording): static
//    {
//        $this->Wording = $Wording;
//        return $this;
//    }
//
//    public function getTimestamp(): ?\DateTimeInterface
//    {
//        return $this->Timestamp;
//    }
//
//    public function setTimestamp(\DateTimeInterface $Timestamp): static
//    {
//        $this->Timestamp = $Timestamp;
//        return $this;
//    }
//
//    public function getDescription(): ?string
//    {
//        return $this->Description;
//    }
//
//    public function setDescription(string $Description): static
//    {
//        $this->Description = $Description;
//        return $this;
//    }
//
//    public function getAddress(): ?string
//    {
//        return $this->Address;
//    }
//
//    public function setAddress(string $Address): static
//    {
//        $this->Address = $Address;
//        return $this;
//    }
//
//    public function getStatus(): ?string
//    {
//        return $this->Status;
//    }
//
//    public function setStatus(string $Status): static
//    {
//        $this->Status = $Status;
//        return $this;
//    }
//
//    public function getUser(): ?Utilisateur
//    {
//        return $this->user;
//    }
//
//    public function setUser(?Utilisateur $user): static
//    {
//        $this->user = $user;
//        return $this;
//    }
//
//    public function getFault(): ?Fault
//    {
//        return $this->fault;
//    }
//
//    public function setFault(?Fault $fault): static
//    {
//        $this->fault = $fault;
//        return $this;
//    }
//
//    public function getVehicle(): ?Vehicle
//    {
//        return $this->vehicle;
//    }
//
//    public function setVehicle(?Vehicle $vehicle): static
//    {
//        $this->vehicle = $vehicle;
//        return $this;
//    }
//
//    public function getStocks(): Collection
//    {
//        return $this->stocks;
//    }
//
//    public function addStock(Stock $stock): static
//    {
//        if (!$this->stocks->contains($stock)) {
//            $this->stocks[] = $stock;
//        }
//        return $this;
//    }
//
//    public function removeStock(Stock $stock): static
//    {
//        $this->stocks->removeElement($stock);
//        return $this;
//    }
//}


namespace App\Entity;

use App\Repository\InterventionRepository;
use Doctrine\DBAL\Types\Types;
use Doctrine\ORM\Mapping as ORM;
use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;

#[ORM\Entity(repositoryClass: InterventionRepository::class)]
class Intervention
{
    #[ORM\Id]
    #[ORM\GeneratedValue]
    #[ORM\Column]
    private ?int $id = null;

    #[ORM\Column(length: 255)]
    private ?string $Wording = null;

    #[ORM\Column(type: Types::DATETIME_MUTABLE)]
    private ?\DateTimeInterface $Timestamp = null;

    #[ORM\Column(length: 255)]
    private ?string $Description = null;

    #[ORM\Column(length: 255)]
    private ?string $Address = null;

    #[ORM\Column(length: 255)]
    private ?string $Status = null;

    #[ORM\Column(type: 'text', nullable: true)]
    private ?string $Remarque = null;

    #[ORM\ManyToOne(inversedBy: 'interventions')]
    #[ORM\JoinColumn(nullable: false)]
    private ?Utilisateur $user = null;

    #[ORM\ManyToOne]
    #[ORM\JoinColumn(nullable: false)]
    private ?Fault $fault = null;

    #[ORM\ManyToOne(inversedBy: 'intervention')]
    private ?Vehicle $vehicle = null;

    #[ORM\ManyToMany(targetEntity: Stock::class)]
    #[ORM\JoinTable(name: "intervention_stock")]
    private Collection $stocks;

    // Ajout de la propriété StartDate
    #[ORM\Column(type: Types::DATETIME_MUTABLE, nullable: true)]
    private ?\DateTimeInterface $startDate = null;

    public function __construct()
    {
        $this->stocks = new ArrayCollection();
    }

    public function getId(): ?int
    {
        return $this->id;
    }

    public function getWording(): ?string
    {
        return $this->Wording;
    }

    public function setWording(string $Wording): static
    {
        $this->Wording = $Wording;
        return $this;
    }

    public function getTimestamp(): ?\DateTimeInterface
    {
        return $this->Timestamp;
    }

    public function setTimestamp(\DateTimeInterface $Timestamp): static
    {
        $this->Timestamp = $Timestamp;
        return $this;
    }

    public function getDescription(): ?string
    {
        return $this->Description;
    }

    public function setDescription(string $Description): static
    {
        $this->Description = $Description;
        return $this;
    }

    public function getAddress(): ?string
    {
        return $this->Address;
    }

    public function setAddress(string $Address): static
    {
        $this->Address = $Address;
        return $this;
    }

    public function getStatus(): ?string
    {
        return $this->Status;
    }

    public function setStatus(string $Status): static
    {
        $this->Status = $Status;
        return $this;
    }

    public function getUser(): ?Utilisateur
    {
        return $this->user;
    }

    public function setUser(?Utilisateur $user): static
    {
        $this->user = $user;
        return $this;
    }

    public function getFault(): ?Fault
    {
        return $this->fault;
    }

    public function setFault(?Fault $fault): static
    {
        $this->fault = $fault;
        return $this;
    }

    public function getVehicle(): ?Vehicle
    {
        return $this->vehicle;
    }

    public function setVehicle(?Vehicle $vehicle): static
    {
        $this->vehicle = $vehicle;
        return $this;
    }

    public function getStocks(): Collection
    {
        return $this->stocks;
    }

    public function addStock(Stock $stock): static
    {
        if (!$this->stocks->contains($stock)) {
            $this->stocks[] = $stock;
        }
        return $this;
    }

    public function removeStock(Stock $stock): static
    {
        $this->stocks->removeElement($stock);
        return $this;
    }

    // Ajout de la méthode getStartDate
    public function getStartDate(): ?\DateTimeInterface
    {
        return $this->startDate;
    }

    public function setStartDate(\DateTimeInterface $startDate): static
    {
        $this->startDate = $startDate;
        return $this;
    }

    // Ajout de la méthode getTitle()
    public function getTitle(): ?string
    {
        return $this->Wording;
    }

    public function getRemarque(): ?string
    {
        return $this->Remarque;
    }

    public function setRemarque(?string $Remarque): void
    {
        $this->Remarque = $Remarque;
    }
}

